unit ecma_extobject;

//ggobject
//2001/4/26 ~
//by Wolfy

{$IFDEF VER130}
{$ELSE}
  {$WARN SYMBOL_PLATFORM OFF}
  {$WARN UNIT_PLATFORM OFF}
{$ENDIF}

interface

uses
  windows,classes,sysutils,dialogs,syncobjs,forms,gsocketmisc,
  ecma_type,ecma_expr,hashtable,regexpr,
  jconvert,ecma_misc,ecma_object,myclasses,FileCtrl,IniFiles,crclib,
  folderdialog,clipbrd,shellapi,registry;

type
  //t@Cobject
  TJFileObject = class(TJObject)
  private
    FFile: TSafeFileStream;
    FFileName: String;

    function DoRead(Param: TJValueList): TJValue;
    function DoOpen(Param: TJValueList): TJValue;
    function DoClose(Param: TJValueList): TJValue;
    function DoIsOpened(Param: TJValueList): TJValue;
    function DoWrite(Param: TJValueList): TJValue;
    function DoWriteln(Param: TJValueList): TJValue;
    function DoFlush(Param: TJValueList): TJValue;
    function DoReadln(Param: TJValueList): TJValue;
    function DoEof(Param: TJValueList): TJValue;
    function DoExists(Param: TJValueList): TJValue;
    function DoRemove(Param: TJValueList): TJValue;
    function DoRenameTo(Param: TJValueList): TJValue;
    function DoCopyTo(Param: TJValueList): TJValue;
    function DoCanRead(Param: TJValueList): TJValue;
    function DoCanWrite(Param: TJValueList): TJValue;
    function DoToString(Param: TJValueList): TJValue;
    function DoSeek(Param: TJValueList): TJValue;
    function GetLength: Integer;
    function GetLatModified: TJDateObject;

  public
    constructor Create(AFactory: TJObjectFactory; Param: TJValueList); override;
    destructor Destroy; override;
  published
    property length: Integer read GetLength;
    property lastModified : TJDateObject read GetLatModified;
    property filename: String read FFilename write FFilename;
  end;
  //fBNg
  TJDirectoryObject = class(TJObject)
  private
    FDirname: String;
    FSearchRec: TSearchRec;
    FBeginFind: Boolean;

    function DoMake(Param: TJValueList): TJValue;
    function DoRemove(Param: TJValueList): TJValue;
    function DoRenameTo(Param: TJValueList): TJValue;
    function DoFindFirst(Param: TJValueList): TJValue;
    function DoFindFirstFile(Param: TJValueList): TJValue;
    function DoFindNext(Param: TJValueList): TJValue;
    function DoFindNextFile(Param: TJValueList): TJValue;
    function DoFindNextDir(Param: TJValueList): TJValue;
    function DoFindFirstDir(Param: TJValueList): TJValue;
    function DoFindClose(Param: TJValueList): TJValue;
    function DoExists(Param: TJValueList): TJValue;
    function DoChangeTo(Param: TJValueList): TJValue;
    procedure SetDirname(const Value: String);
  public
    constructor Create(AFactory: TJObjectFactory; Param: TJValueList); override;
    destructor Destroy; override;
  published
    property dirname: String read FDirname write SetDirname;
  end;
  //񃊃Xg
  TJStringsObject = class(TJObject)
  private
    FStrings: TStringList;

    function DoAdd(Param: TJValueList): TJValue;
    function DoInsert(Param: TJValueList): TJValue;
    function DoDelete(Param: TJValueList): TJValue;
    function DoClear(Param: TJValueList): TJValue;
    function DoIndxOf(Param: TJValueList): TJValue;
    function DoSort(Param: TJValueList): TJValue;
    function DoSaveToFile(Param: TJValueList): TJValue;
    function DoLoadFromFile(Param: TJValueList): TJValue;
    function DoAssign(Param: TJValueList): TJValue;
    function DoAddStrings(Param: TJValueList): TJValue;
    function GetCommaText: String;
    function GetCount: Integer;
    function GetSorted: Boolean;
    function GetText: String;
    procedure SetSorted(const Value: Boolean);
    procedure SetCommaText(const Value: String);
    procedure SetText(const Value: String);

  protected
    function GetPropertyList: String; override;
  public
    constructor Create(AFactory: TJObjectFactory; Param: TJValueList); override;
    destructor Destroy; override;
    function GetValue(S: String; ArrayStyle: Boolean): TJValue; override;
    procedure SetValue(S: String; Value: TJValue; ArrayStyle: Boolean); override;
    property Strings: TStringList read FStrings;
  published
    property text: String read GetText write SetText;
    property commaText: String read GetCommaText write SetCommaText;
    property length: Integer read GetCount;
    property count: Integer read GetCount;
    property sorted: Boolean read GetSorted write SetSorted;
  end;
  //win32 APIȂ
  TJWin32Object = class(TJObject)
  private
    function DoSleep(Param: TJValueList): TJValue;
    function DoWinExec(Param: TJValueList): TJValue;
    function DoProcessMessages(Param: TJValueList): TJValue;
    function DoShellExecute(Param: TJValueList): TJValue;
  public
    constructor Create(AFactory: TJObjectFactory; Param: TJValueList); override;
    destructor Destroy; override;
  end;
  //init@C
  TJIniObject = class(TJObject)
  private
    FIni: TMemIniFile;
    function DoDeleteKey(Param: TJValueList): TJValue;
    function DoEraseSection(Param: TJValueList): TJValue;
    function DoReadSection(Param: TJValueList): TJValue;
    function DoReadSections(Param: TJValueList): TJValue;
    function DoSectionExists(Param: TJValueList): TJValue;
    function DoWrite(Param: TJValueList): TJValue;
    function DoRead(Param: TJValueList): TJValue;
    function GetFilename: String;
  public
    constructor Create(AFactory: TJObjectFactory; Param: TJValueList); override;
    destructor Destroy; override;
  published
    property filename: String read GetFilename;
  end;
  //CRC
  TJCRCObject = class(TJObject)
  private
    FCRC16: Word;
    FCRC32: DWord;
    function DoCalc(Param: TJValueList): TJValue;
    function DoCalcFile(Param: TJValueList): TJValue;
    function GetCRC16: Integer;
    function GetCRC32: Integer;
  public
    constructor Create(AFactory: TJObjectFactory; Param: TJValueList); override;
  published
    property CRC16: Integer read GetCRC16;
    property CRC32: Integer read GetCRC32;
  end;
  //base64
  TJBase64Object = class(TJObject)
  private
    function DoEncode(Param: TJValueList): TJValue;
    function DoDecode(Param: TJValueList): TJValue;
    function DoEncodeHeader(Param: TJValueList): TJValue;
    function DoDecodeHeader(Param: TJValueList): TJValue;
  public
    constructor Create(AFactory: TJObjectFactory; Param: TJValueList); override;
  end;
  //_CAO
  TJDialogObject = class(TJObject)
  private
    function DoOpenFile(Param: TJValueList): TJValue;
    function DoOpenFiles(Param: TJValueList): TJValue;
    function DoSaveFile(Param: TJValueList): TJValue;
    function DoOpenFolder(Param: TJValueList): TJValue;
  public
    constructor Create(AFactory: TJObjectFactory; Param: TJValueList); override;
  end;

  TJMutexObject = class(TJObject)
  private
    FMutex: TMutex;
    function DoLock(Param: TJValueList): TJValue;
    function DoUnLock(Param: TJValueList): TJValue;
    function DoTryLock(Param: TJValueList): TJValue;
    function GetTimeout: Integer;
    procedure SetTimeout(const Value: Integer);
    function GetExisted: Boolean;
  public
    constructor Create(AFactory: TJObjectFactory; Param: TJValueList); override;
    destructor Destroy; override;
  published
    property timeout: Integer read GetTimeout write SetTimeout;
    property existed: Boolean read GetExisted;
  end;

  //keyboard
  TJKeyboard = class(TJObject)
  private
    function GetAlt: Boolean;
    function GetCtrl: Boolean;
    function GetShift: Boolean;
  protected
    function DoIsDown(Param: TJValueList): TJValue;
  public
    constructor Create(AFactory: TJObjectFactory; Param: TJValueList); override;
  published
    property shift: Boolean read GetShift;
    property ctrl: Boolean read GetCtrl;
    property alt: Boolean read GetAlt;
  end;

  //mouse
  TJMouse = class(TJObject)
  private
    function GetLButton: Boolean;
    function GetMButton: Boolean;
    function GetRButton: Boolean;
    function GetX: Integer;
    function GetY: Integer;
  protected

  public
    constructor Create(AFactory: TJObjectFactory; Param: TJValueList); override;
  published
    property lbutton: Boolean read GetLButton;
    property mbutton: Boolean read GetMButton;
    property rbutton: Boolean read GetRButton;
    property x: Integer read GetX;
    property y: Integer read GetY;
  end;

  //clipboard
  TJClipboard = class(TJObject)
  private
    function GetAsText: String;
    procedure SetAsText(const Value: String);
  protected
    function DoHasText(Param: TJValueList): TJValue;
  public
    constructor Create(AFactory: TJObjectFactory; Param: TJValueList); override;
  published
    property asText: String read GetAsText write SetAsText;
  end;

  //init@C
  TJRegIniObject = class(TJObject)
  private
    FReg: TRegIniFile;

    function DoDeleteKey(Param: TJValueList): TJValue;
    function DoEraseSection(Param: TJValueList): TJValue;
    function DoReadSection(Param: TJValueList): TJValue;
    function DoReadSections(Param: TJValueList): TJValue;
    function DoSectionExists(Param: TJValueList): TJValue;
    function DoWrite(Param: TJValueList): TJValue;
    function DoRead(Param: TJValueList): TJValue;
    function GetKey: String;
    function GetRootKey: String;
  public
    constructor Create(AFactory: TJObjectFactory; Param: TJValueList); override;
    destructor Destroy; override;
  published
    property rootKey: String read GetRootKey;
    property key: String read GetKey;
  end;



implementation

{ TJFileObject }

constructor TJFileObject.Create(AFactory: TJObjectFactory;
  Param: TJValueList);
var
  v: TJValue;
begin
  inherited Create(AFactory,nil);
  RegistName('File');
  FFile := TSafeFileStream.Create;
  //t@Cݒ
  if IsParam1(Param) then
  begin
    v := Param[0];
    FFilename := AsString(@v);
  end;

  RegistMethod('read',DoRead);
  RegistMethod('open',DoOpen);
  RegistMethod('close',DoClose);
  RegistMethod('isOpened',DoIsOpened);
  RegistMethod('write',DoWrite);
  RegistMethod('writeln',DoWriteln);
  RegistMethod('flush',DoFlush);
  RegistMethod('readln',DoReadln);
  RegistMethod('eof',DoEof);
  RegistMethod('exists',DoExists);
  RegistMethod('remove',DoRemove);
  RegistMethod('renameTo',DoRenameTo);
  RegistMethod('copyTo',DoCopyTo);
  RegistMethod('canRead',DoCanRead);
  RegistMethod('canWrite',DoCanWrite);
  RegistMethod('toString',DoToString);
  RegistMethod('seek',DoSeek);
end;

destructor TJFileObject.Destroy;
begin
  FFile.Close;
  FFile.Free;
  inherited;
end;

function TJFileObject.DoCanRead(Param: TJValueList): TJValue;
begin
  Result := BuildBool((FFile.Mode and fmOpenRead) <> 0);
end;

function TJFileObject.DoCanWrite(Param: TJValueList): TJValue;
begin
  Result := BuildBool((FFile.Mode and fmOpenWrite) <> 0);
end;

function TJFileObject.DoClose(Param: TJValueList): TJValue;
//t@C
begin
  Result := BuildBool(FFile.IsOpened);
  FFile.Close;  
end;

function TJFileObject.DoCopyTo(Param: TJValueList): TJValue;
//Rs[
var
  v: TJValue;
  s: String;
begin
  FFile.Close;
  if IsParam1(Param) then
  begin
    v := Param[0];
    s := AsString(@v);
    if CopyFile(PChar(FFilename),PChar(s),False) then
    begin
      Result := BuildBool(True);
    end
    else
      raise EJThrow.Create(E_FILE,'copy error: ' + FFilename);
  end
  else
    raise EJThrow.Create(E_FILE,'copy error: ' + FFilename);  
end;

function TJFileObject.DoEof(Param: TJValueList): TJValue;
begin
  if FFile.IsOpened then
  begin
    Result := BuildBool(FFile.Position = FFile.Size);
  end
  else
    raise EJThrow.Create(E_FILE,'eof error: ' + FFilename);
end;

function TJFileObject.DoExists(Param: TJValueList): TJValue;
begin
  Result := BuildBool(FileExists(FFilename));
end;

function TJFileObject.DoFlush(Param: TJValueList): TJValue;
begin
  Result := BuildBool(FFile.IsOpened);
  FFile.Flush;
end;

function TJFileObject.DoIsOpened(Param: TJValueList): TJValue;
begin
  Result := BuildBool(FFile.IsOpened);
end;

function TJFileObject.DoOpen(Param: TJValueList): TJValue;
//t@CJ
var
  v: TJValue;
  mode: Integer;
  s: String;
begin
  Result := BuildBool(True);
  mode := 0;
  if IsParam1(Param) then
  begin
    //t@C[h
    v := Param[0];
    s := LowerCase(AsString(@v));
    if Pos('r',s) > 0 then
      mode := fmOpenRead;

    if Pos('w',s) > 0 then
      mode := mode or fmOpenWrite;

    if Pos('d',s) > 0 then
      mode := mode or fmShareDenyWrite;
  end
  else
    mode := fmOpenRead or fmShareDenyWrite;
  //t@CJ
  try
    FFile.Open(FFilename,mode,True);
  except
    on EFOpenError do
      raise EJThrow.Create(E_FILE,'can not open: ' + FFilename);
  end;
end;

function TJFileObject.DoRead(Param: TJValueList): TJValue;
const
  BUFSIZE = 65535;
var
  s,buf: String;
  res,size: Integer;
  v: TJValue;
begin
  Result := BuildNull;
  s := '';
  if FFile.IsOpened then
  begin
    try
      if IsParam1(Param) then
      begin
        v := Param[0];
        size := AsInteger(@v);
        //wTCYǂݍ
        SetLength(s,size);
        FFile.Read(s[1],size);
        Result := BuildString(s);
      end
      else begin
        //Sēǂ
        SetLength(buf,BUFSIZE);
        repeat
          res := FFile.Read(buf[1],BUFSIZE);
          if res > 0 then
            s := s + Copy(buf,1,res);

        until (res <= 0);
        Result := BuildString(s);
      end;
    except
      raise EJThrow.Create(E_FILE,'read error: ' + FFilename);
    end;
  end
  else
    raise EJThrow.Create(E_FILE,'read error: ' + FFilename);
end;

function TJFileObject.DoReadln(Param: TJValueList): TJValue;
const
  BUFSIZE = 65535;
var
  s,buf: String;
  res,index,currentpos: Integer;
begin
  Result := BuildNull;
  s := '';
  if FFile.IsOpened then
  begin
    try
      //s܂œǂ
      SetLength(buf,BUFSIZE);
      repeat
        currentpos := FFile.Position;
        res := FFile.Read(buf[1],BUFSIZE);
        if res > 0 then
        begin
          index := Pos(LF,buf);
          if index > 0 then
          begin
            s := s + Copy(buf,1,index);
            s := TrimRight(s);
            FFile.Position := currentpos + index;
            Break;
          end
          else
            s := s + Copy(buf,1,res);
        end;

      until (res <= 0);
      Result := BuildString(s);
    except
      raise EJThrow.Create(E_FILE,'read error: ' + FFilename);
    end;
  end
  else
    raise EJThrow.Create(E_FILE,'read error: ' + FFilename);


end;

function TJFileObject.DoRemove(Param: TJValueList): TJValue;
//t@C폜
begin
  FFile.Close;
  if DeleteFile(FFilename) then
    Result := BuildBool(True)
  else
    raise EJThrow.Create(E_FILE,'remove error: ' + FFilename);
end;

function TJFileObject.DoRenameTo(Param: TJValueList): TJValue;
//l[
var
  v: TJValue;
  s: String;
begin
  FFile.Close;
  if IsParam1(Param) then
  begin
    v := Param[0];
    s := AsString(@v);
    if RenameFile(FFilename,s) then
    begin
      FFilename := s;
      Result := BuildBool(True);
    end
    else
      raise EJThrow.Create(E_FILE,'rename error: ' + FFilename);
  end
  else
    raise EJThrow.Create(E_FILE,'rename error: ' + FFilename);
end;

function TJFileObject.DoSeek(Param: TJValueList): TJValue;
var
  v: TJValue;
  po: Integer;
begin
  if FFile.IsOpened and IsParam1(Param) then
  begin
    v := Param[0];
    po := AsInteger(@v);
    if po < 0 then
      po := FFile.Size + po;

    try
      Result := BuildInteger(FFile.Seek(po,soFromBeginning));
    except
      raise EJThrow.Create(E_FILE,'seek error: ' + FFilename);
    end;
  end
  else
    raise EJThrow.Create(E_FILE,'seek error: ' + FFilename); 
end;

function TJFileObject.DoToString(Param: TJValueList): TJValue;
begin
  Result := BuildString(FFilename);
end;

function TJFileObject.DoWrite(Param: TJValueList): TJValue;
const
  BUFSIZE = 65535;
var
  s: String;
  res,size,index: Integer;
  v: TJValue;
begin
  Result := BuildNull;
  if FFile.IsOpened then
  begin
    try
      v := Param[0];
      s := AsString(@v);
      index := 1;
      size := system.Length(s);
      res := 0;
      repeat
        if size > 0 then
          res := FFile.Write(s[index],size)
        else
          Break;
          
        if res > 0 then
        begin
          Inc(index,res);
          Dec(size,res);
        end;
      until (res <= 0);
      //݃TCYԂ
      Result := BuildInteger(index - 1);
    except
      raise EJThrow.Create(E_FILE,'write error: ' + FFilename);
    end;
  end
  else
    raise EJThrow.Create(E_FILE,'write error: ' + FFilename);
end;

function TJFileObject.DoWriteln(Param: TJValueList): TJValue;
//st
var
  v: TJValue;
  s: String;
begin
  if IsParam1(Param) then
  begin
    v := Param[0];
    s := AsString(@v) + CRLF;
    Param.Clear;
    Param.Add(BuildString(s));
  end;
  Result := DoWrite(Param);
end;

function TJFileObject.GetLatModified: TJDateObject;
//t@C̓tԂ
var
  res: Integer;
  date: TDateTime;
begin
  Result := TJDateObject.Create(FFactory,nil);

  res := FileAge(FFilename);
  if res = -1 then
    date := Now
  else
    date := FileDateToDateTime(res);

  Result.LocalTime := date;
end;

function TJFileObject.GetLength: Integer;
//t@CTCYԂ
begin
  if FFile.IsOpened then
    Result := FFile.Size
  else //O
    raise EJThrow.Create(E_FILE,'length error: ' + FFilename);
end;

{ TJDirectoryObject }

constructor TJDirectoryObject.Create(AFactory: TJObjectFactory;
  Param: TJValueList);
var
  v: TJValue;
begin
  inherited Create(AFactory,nil);
  RegistName('Directory');

  if IsParam1(Param) then
  begin
    v := Param[0];
    FDirname := CheckPath(AsString(@v),PATH_DOS);
  end;

  RegistMethod('make',DoMake);
  RegistMethod('remove',DoRemove);
  RegistMethod('renameTo',DoRenameTo);
  RegistMethod('findFirstFile',DoFindFirstFile);
  RegistMethod('findNext',DoFindNext);
  RegistMethod('findNextFile',DoFindNextFile);
  RegistMethod('findNextDir',DoFindNextDir);
  RegistMethod('findFirstDir',DoFindFirstDir);
  RegistMethod('findFirst',DoFindFirst);
  RegistMethod('findClose',DoFindClose);
  RegistMethod('exists',DoExists);
  RegistMethod('changeTo',DoChangeTo);
end;

destructor TJDirectoryObject.Destroy;
begin
  if FBeginFind then
    FindClose(FSearchRec);

  inherited;
end;

function TJDirectoryObject.DoChangeTo(Param: TJValueList): TJValue;
begin
  EmptyValue(Result);
  ChDir(FDirname);
end;

function TJDirectoryObject.DoExists(Param: TJValueList): TJValue;
begin
  Result := BuildBool(DirectoryExists(FDirName));
end;

function TJDirectoryObject.DoFindClose(Param: TJValueList): TJValue;
begin
  if FBeginFind then
    FindClose(FSearchRec);

  FBeginFind := False;
end;

function TJDirectoryObject.DoFindFirst(Param: TJValueList): TJValue;
begin
  if FBeginFind then
    FindClose(FSearchRec)
  else
    FBeginFind := True;

  if FindFirst(FDirname + '*.*',faAnyFile,FSearchRec) = 0 then
  begin
    Result := BuildString(FSearchRec.Name);
  end
  else
    Result := BuildNull;
end;

function TJDirectoryObject.DoFindFirstDir(Param: TJValueList): TJValue;
begin
  if FBeginFind then
    FindClose(FSearchRec)
  else
    FBeginFind := True;

  if FindFirst(FDirname + '*.*',faDirectory,FSearchRec) = 0 then
  begin
    Result := BuildString(FSearchRec.Name);
  end
  else
    Result := BuildNull;
end;

function TJDirectoryObject.DoFindFirstFile(Param: TJValueList): TJValue;
begin
  if FBeginFind then
    FindClose(FSearchRec)
  else
    FBeginFind := True;

  if FindFirst(FDirname + '*.*',
       faReadOnly or faHidden or faSysFile or faArchive,FSearchRec) = 0 then
  begin
    Result := BuildString(FSearchRec.Name);
  end
  else
    Result := BuildNull;
end;

function TJDirectoryObject.DoFindNext(Param: TJValueList): TJValue;
begin
  if not FBeginFind then
    raise EJThrow.Create(E_DIR,'findNext error: ' + FDirName);

  if FindNext(FSearchRec) = 0 then
  begin
    Result := BuildString(FSearchRec.Name);
  end
  else
    Result := BuildNull;
end;

function TJDirectoryObject.DoFindNextDir(Param: TJValueList): TJValue;
begin
  if not FBeginFind then
    raise EJThrow.Create(E_DIR,'findNextDir error: ' + FDirName);

  Result := BuildNull;
  while FindNext(FSearchRec) = 0 do
  begin
    if (FSearchRec.Attr and faDirectory) <> 0 then
    begin
      //if (FSearchRec.Name = '.') or (FSearchRec.Name = '..') then
      //  Continue
      //else begin
        Result := BuildString(FSearchRec.Name);
        Break;
      //end;
    end
    else
      Continue;
  end;
end;

function TJDirectoryObject.DoFindNextFile(Param: TJValueList): TJValue;
var
  attr: Integer;
begin
  if not FBeginFind then
    raise EJThrow.Create(E_DIR,'findNextFile error: ' + FDirName);

  Result := BuildNull;
  attr := faDirectory or faVolumeID;
  while FindNext(FSearchRec) = 0 do
  begin
    if (FSearchRec.Attr and attr) <> 0 then
    begin
      Continue;
    end
    else begin
      Result := BuildString(FSearchRec.Name);
      Break;
    end;
  end;
end;

function TJDirectoryObject.DoMake(Param: TJValueList): TJValue;
begin
  Result := BuildBool(True);
  try
    if not ForceDirectories(FDirname) then
      raise EJThrow.Create(E_DIR,'make error: ' + FDirName);;
  except
    raise EJThrow.Create(E_DIR,'make error: ' + FDirName);
  end;
end;

function TJDirectoryObject.DoRemove(Param: TJValueList): TJValue;
begin
  Result := BuildBool(True);
  try
    if not RemoveDir(FDirname) then
      raise EJThrow.Create(E_DIR,'remove error: ' + FDirName);
  except
    raise EJThrow.Create(E_DIR,'remove error: ' + FDirName);
  end;
end;

function TJDirectoryObject.DoRenameTo(Param: TJValueList): TJValue;
begin
  //
  EmptyValue(Result);
end;

procedure TJDirectoryObject.SetDirname(const Value: String);
begin
  FDirname := CheckPath(Value,PATH_DOS);
end;

{ TJStringsObject }

constructor TJStringsObject.Create(AFactory: TJObjectFactory;
  Param: TJValueList);
begin
  inherited Create(AFactory,nil);
  RegistName('StringList');

  FStrings := TStringList.Create;

  RegistMethod('add',DoAdd);
  RegistMethod('insert',DoInsert);
  RegistMethod('delete',DoDelete);
  RegistMethod('clear',DoClear);
  RegistMethod('indexOf',DoIndxOf);
  RegistMethod('sort',DoSort);
  RegistMethod('saveToFile',DoSaveToFile);
  RegistMethod('loadFromFile',DoLoadFromFile);
  RegistMethod('assign',DoAssign);
  RegistMethod('addStrings',DoAddStrings);  
end;

destructor TJStringsObject.Destroy;
begin
  FStrings.Free;
  inherited;
end;

function TJStringsObject.DoAdd(Param: TJValueList): TJValue;
var
  v: TJValue;
begin
  if IsParam1(Param) then
  begin
    v := Param[0];
    Result := BuildInteger(FStrings.Add(AsString(@v)));
  end
  else
    Result := BuildInteger(FStrings.Add(''));
end;

function TJStringsObject.DoAddStrings(Param: TJValueList): TJValue;
var
  v: TJValue;
  i: Integer;
  a: TJArrayObject;
begin
  Emptyvalue(Result);
  if IsParam1(Param) then
  begin
    v := Param[0];
    if IsObject(@v) then
    begin
      if v.vObject is TJStringsObject then
        FStrings.AddStrings((v.vObject as TJStringsObject).FStrings)
      else if v.vObject is TJArrayObject then
      begin
        a := v.vObject as TJArrayObject;
        for i := 0 to a.length - 1 do
        begin
          v := a.GetValue(IntToStr(i),True);
          FStrings.Add(AsString(@v))
        end;
      end
      else
        raise EJThrow.Create(E_STRINGS,'addStrings error');
    end
    else
      DoAdd(Param);
  end
  else
    raise EJThrow.Create(E_STRINGS,'assStrings error');
end;

function TJStringsObject.DoAssign(Param: TJValueList): TJValue;
begin
  FStrings.Clear;
  Result := DoAddStrings(Param);
end;

function TJStringsObject.DoClear(Param: TJValueList): TJValue;
begin
  Result := BuildBool(True);
  FStrings.Clear;
end;

function TJStringsObject.DoDelete(Param: TJValueList): TJValue;
var
  v: TJValue;
begin
  EmptyValue(Result);
  if IsParam1(Param) then
  begin
    v := Param[0];
    FStrings.Delete(AsInteger(@v));
  end
  else
    raise EJThrow.Create(E_STRINGS,'delete error');
end;

function TJStringsObject.DoIndxOf(Param: TJValueList): TJValue;
var
  v: TJValue;
begin
  if IsParam1(Param) then
  begin
    v := Param[0];
    Result := BuildInteger(FStrings.IndexOf(AsString(@v)));
  end
  else
    Result := BuildInteger(-1);
end;

function TJStringsObject.DoInsert(Param: TJValueList): TJValue;
var
  v: TJValue;
  s: String;
  index: Integer;
begin
  if IsParam2(Param) then
  begin
    v := Param[0];
    index := AsInteger(@v);
    v := Param[1];
    s := AsString(@v);
    FStrings.Insert(index,s);
  end
  else
    raise EJThrow.Create(E_STRINGS,'insert error');
end;

function TJStringsObject.DoLoadFromFile(Param: TJValueList): TJValue;
var
  v: TJValue;
  s: String;
begin
  Result := BuildBool(True);
  if IsParam1(Param) then
  begin
    v := Param[0];
    s := AsString(@v);
    try
      FStrings.LoadFromFile(s);
    except
      raise EJThrow.Create(E_STRINGS,'loadFromFile error');
    end
  end
  else
    raise EJThrow.Create(E_STRINGS,'loadFromFile error');
end;

function TJStringsObject.DoSaveToFile(Param: TJValueList): TJValue;
var
  v: TJValue;
  s: String;
begin
  Result := BuildBool(True);
  if IsParam1(Param) then
  begin
    v := Param[0];
    s := AsString(@v);
    try
      FStrings.SaveToFile(s);
    except
      raise EJThrow.Create(E_STRINGS,'saveToFile error');
    end
  end
  else
    raise EJThrow.Create(E_STRINGS,'saveToFile error');
end;

function TJStringsObject.DoSort(Param: TJValueList): TJValue;
begin
  FStrings.Sort;
end;

function TJStringsObject.GetCommaText: String;
begin
  Result := FStrings.CommaText;
end;

function TJStringsObject.GetCount: Integer;
begin
  Result := FStrings.Count;
end;

function TJStringsObject.GetPropertyList: String;
var
  i: Integer;
begin
  Result := '';
  for i := 0 to FStrings.Count - 1 do
    Result := Result + IntToStr(i) + #13#10;

  Result := Trim(Result);
end;

function TJStringsObject.GetSorted: Boolean;
begin
  Result := FStrings.Sorted;
end;

function TJStringsObject.GetText: String;
begin
  Result := FStrings.Text;
end;

function TJStringsObject.GetValue(S: String;
  ArrayStyle: Boolean): TJValue;
var
  i: Integer;
begin
  if not ArrayStyle then
    Result := inherited GetValue(S,ArrayStyle)
  else begin
    try
      i := StrToInt(S);
      Result := BuildString(FStrings[i]);
    except
      on EConvertError do
        Result := inherited GetValue(S,ArrayStyle);
      else
        raise EJThrow.Create(E_INDEX,S);
    end;
  end;
end;

procedure TJStringsObject.SetCommaText(const Value: String);
begin
  FStrings.CommaText := Value;
end;

procedure TJStringsObject.SetSorted(const Value: Boolean);
begin
  FStrings.Sorted := Value;
end;

procedure TJStringsObject.SetText(const Value: String);
begin
  FStrings.Text := Value;
end;

procedure TJStringsObject.SetValue(S: String; Value: TJValue;
  ArrayStyle: Boolean);
var
  i: Integer;
begin
  if ArrayStyle then
  begin
    try
      i := StrToInt(S);
      FStrings[i] := AsString(@Value);
    except
      on EConvertError do
        inherited SetValue(S,Value,ArrayStyle);
      else
        raise EJThrow.Create(E_INDEX,S);
    end;
  end
  else
    inherited SetValue(S,Value,ArrayStyle);
end;

{ TJWin32Object }

constructor TJWin32Object.Create(AFactory: TJObjectFactory;
  Param: TJValueList);
begin
  inherited Create(AFactory,nil);
  RegistName('Win32');

  RegistMethod('sleep',DoSleep);
  RegistMethod('WinExec',DoWinExec);
  RegistMethod('processMessages',DoProcessMessages);
  RegistMethod('shellExecute',DoShellExecute);
end;

destructor TJWin32Object.Destroy;
begin
  inherited;    
end;

function TJWin32Object.DoProcessMessages(Param: TJValueList): TJValue;
begin
  EmptyValue(Result);
  Application.ProcessMessages;
end;

function TJWin32Object.DoShellExecute(Param: TJValueList): TJValue;
var
  v: TJValue;
  op,name,args,dir: String;
begin
  Result := BuildBool(False);   

  if IsParam1(Param) then
  begin
    args := '';
    dir := '';

    v := Param[0];
    op := AsString(@v);
    if IsParam2(Param) then
    begin
      v := Param[1];
      name := AsString(@v);
      if IsParam3(Param) then
      begin
        v := Param[2];
        args := AsString(@v);
        if IsParam4(Param) then
        begin
          v := Param[3];
          dir := AsString(@v);
        end;
      end;

      //s
      Result := BuildBool(ShellExecute(0,PChar(op),PChar(name),PChar(args),PChar(dir),SW_SHOW) > 32);
    end
    else
      raise EJThrow.Create(E_WIN32,'shellExecute error');
  end
  else
    raise EJThrow.Create(E_WIN32,'shellExecute error'); 
end;

function TJWin32Object.DoSleep(Param: TJValueList): TJValue;
//sleep
var
  v: TJValue;
  i: Integer;
begin
  EmptyValue(Result);
  if IsParam1(Param) then
  begin
    v := Param[0];
    i := AsInteger(@v);
    Sleep(i);
  end;
end;

function TJWin32Object.DoWinExec(Param: TJValueList): TJValue;
var
  v: TJValue;
  s: String;
begin
  Result := BuildBool(False);
  if IsParam1(Param) then
  begin
    v := Param[0];
    s := AsString(@v);
    Result := BuildBool(WinExec(PChar(s),SW_SHOW) > 32);
  end
  else
    raise EJThrow.Create(E_WIN32,'WinExec error');
end;

{ TJIniObject }

constructor TJIniObject.Create(AFactory: TJObjectFactory;
  Param: TJValueList);
var
  v: TJValue;
begin
  inherited Create(AFactory,nil);
  RegistName('Ini');

  RegistMethod('deleteKey',DoDeleteKey);
  RegistMethod('eraseSection',DoEraseSection);
  RegistMethod('readSection',DoReadSection);
  RegistMethod('readSections',DoReadSections);
  RegistMethod('sectionExists',DoSectionExists);
  RegistMethod('write',DoWrite);
  RegistMethod('read',DoRead);

  if IsParam1(Param) then
  begin
    v := Param[0];
    try
      FIni := TMemIniFile.Create(AsString(@v));
    except
      raise EJThrow.Create(E_INI,'ini create error');
    end;
  end
  else
    raise EJThrow.Create(E_INI,'ini create error');
end;

destructor TJIniObject.Destroy;
begin
  FIni.Free;
  inherited;
end;

function TJIniObject.DoDeleteKey(Param: TJValueList): TJValue;
var
  v1,v2: TJValue;
begin
  EmptyValue(Result);
  if IsParam2(Param) then
  begin
    v1 := Param[0];
    v2 := Param[1];
    FIni.DeleteKey(AsString(@v1),AsString(@v2));
  end
  else
    raise EJThrow.Create(E_INI,'deleteKey error: ' + FIni.Filename);
end;

function TJIniObject.DoEraseSection(Param: TJValueList): TJValue;
var
  v1: TJValue;
begin
  EmptyValue(Result);
  if IsParam1(Param) then
  begin
    v1 := Param[0];
    try
      FIni.EraseSection(AsString(@v1));
    except
      raise EJThrow.Create(E_INI,'eraseSection error: ' + FIni.Filename);
    end;
  end
  else
    raise EJThrow.Create(E_INI,'eraseSection error: ' + FIni.Filename);
end;

function TJIniObject.DoRead(Param: TJValueList): TJValue;
var
  v1,v2,v3: TJValue;
begin
  EmptyValue(Result);
  if IsParam3(Param) then
  begin
    v1 := Param[0];
    v2 := Param[1];
    v3 := Param[2];
    Result := BuildString(FIni.ReadString(AsString(@v1),AsString(@v2),AsString(@v3)));
  end
  else
    raise EJThrow.Create(E_INI,'read error: ' + FIni.Filename);
end;

function TJIniObject.DoReadSection(Param: TJValueList): TJValue;
var
  v1: TJValue;
  sl: TStringList;
  ss: TJStringsObject;
begin
  EmptyValue(Result); 
  if IsParam1(Param) then
  begin
    v1 := Param[0];
    sl := TStringList.Create;
    try try
      FIni.ReadSection(AsString(@v1),sl);
      ss := TJStringsObject.Create(FFactory,nil);
      ss.FStrings.Assign(sl);
      Result := BuildObject(ss);
    except
      raise EJThrow.Create(E_INI,'readSection error: ' + FIni.Filename);
    end;
    finally
      sl.Free;
    end;
  end
  else
    raise EJThrow.Create(E_INI,'readSection error: ' + FIni.Filename);

end;

function TJIniObject.DoReadSections(Param: TJValueList): TJValue;
var
  sl: TStringList;
  ss: TJStringsObject;
begin
  EmptyValue(Result);
  sl := TStringList.Create;
  try try
    FIni.ReadSections(sl);
    ss := TJStringsObject.Create(FFactory,nil);
    ss.FStrings.Assign(sl);
    Result := BuildObject(ss);
  except
    raise EJThrow.Create(E_INI,'readSections error: ' + FIni.Filename);
  end;
  finally
    sl.Free;
  end;

end;

function TJIniObject.DoSectionExists(Param: TJValueList): TJValue;
var
  v: TJValue;
begin
  if IsParam1(Param) then
  begin
    v := Param[0];
    Result := BuildBool(FIni.SectionExists(AsString(@v)));
  end
  else
    Result := BuildBool(False);
end;

function TJIniObject.DoWrite(Param: TJValueList): TJValue;
var
  v1,v2,v3: TJValue;
begin
  EmptyValue(Result);
  if IsParam3(Param) then
  begin
    v1 := Param[0];
    v2 := Param[1];
    v3 := Param[2];
    FIni.WriteString(AsString(@v1),AsString(@v2),AsString(@v3));
  end
  else
    raise EJThrow.Create(E_INI,'write error: ' + FIni.Filename);
end;

function TJIniObject.GetFilename: String;
begin
  Result := FIni.FileName;
end;

{ TJCRCObject }

function TJCRCObject.DoCalc(Param: TJValueList): TJValue;
var
  v: TJValue;
begin
  if IsParam1(Param) then
  begin
    v := Param[0];
    CalcStringCRC(FCRC16,FCRC32,AsString(@v));
  end
  else
    raise EJThrow.Create(E_CRC,'calc error');
end;

function TJCRCObject.DoCalcFile(Param: TJValueList): TJValue;
var
  v: TJValue;
begin
  if IsParam1(Param) then
  begin
    v := Param[0];
    if not CalcFileCRC(FCRC16,FCRC32,AsString(@v)) then
      raise EJThrow.Create(E_CRC,'calcFile error');
  end
  else
    raise EJThrow.Create(E_CRC,'calcFile error');
end;

constructor TJCRCObject.Create(AFactory: TJObjectFactory;
  Param: TJValueList);
begin
  inherited;
  RegistName('CRC');

  FCRC16 := $FFFF;
  FCRC32 := $FFFFFFFF;
  RegistMethod('calc',DoCalc);
  RegistMethod('calcFile',DoCalcFile);
end;

function TJCRCObject.GetCRC16: Integer;
begin
  Result := FCRC16;
end;

function TJCRCObject.GetCRC32: Integer;
begin
  Result := FCRC32;
end;

{ TJBase64Object }

constructor TJBase64Object.Create(AFactory: TJObjectFactory;
  Param: TJValueList);
begin
  inherited;
  RegistName('Base64');

  RegistMethod('encode',DoEncode);
  RegistMethod('decode',DoDecode);
  RegistMethod('encodeHeader',DoEncodeHeader);
  RegistMethod('decodeHeader',DoDecodeHeader);
end;

function TJBase64Object.DoDecode(Param: TJValueList): TJValue;
var
  v: TJValue;
begin
  if IsParam1(Param) then
  begin
    v := Param[0];
    Result := BuildString(DecodeBase64(AsString(@v)));
  end
  else
    raise EJThrow.Create(E_BASE64,'decode error');
end;

function TJBase64Object.DoDecodeHeader(Param: TJValueList): TJValue;
var
  v: TJValue;
begin
  if IsParam1(Param) then
  begin
    v := Param[0];
    Result := BuildString(jis2sjis(DecodeHeaderString(AsString(@v))));
  end
  else
    raise EJThrow.Create(E_BASE64,'decodeHeader error');
end;

function TJBase64Object.DoEncode(Param: TJValueList): TJValue;
var
  v: TJValue;
begin
  if IsParam1(Param) then
  begin
    v := Param[0];
    Result := BuildString(EncodeBase64(AsString(@v)));
  end
  else
    raise EJThrow.Create(E_BASE64,'encode error');
end;

function TJBase64Object.DoEncodeHeader(Param: TJValueList): TJValue;
var
  v: TJValue;
begin
  if IsParam1(Param) then
  begin
    v := Param[0];
    Result := BuildString(CreateHeaderString(AsString(@v)));
  end
  else
    raise EJThrow.Create(E_BASE64,'encodeHeader error');
end;

{ TJDialogObject }

constructor TJDialogObject.Create(AFactory: TJObjectFactory;
  Param: TJValueList);
begin
  inherited;
  RegistName('Dialog');

  RegistMethod('openFile',DoOpenFile);
  RegistMethod('openFiles',DoOpenFiles);
  RegistMethod('saveFile',DoSaveFile);
  RegistMethod('openFolder',DoOpenFolder);
end;

function TJDialogObject.DoOpenFile(Param: TJValueList): TJValue;
//open dialogJ
var
  dialog: TOpenDialog;
  v: TJValue;
  title,default: String;
begin
  Result := BuildNull;
  title := ChangeFileExt(ExtractFileName(ParamStr(0)),'');
  default := '';
  //^Cg
  if IsParam1(Param) then
  begin
    v := Param[0];
    title := AsString(@v);
  end;
  //ftHgt@C
  if IsParam2(Param) then
  begin
    v := Param[1];
    default := AsString(@v);
  end;

  dialog := TOpenDialog.Create(nil);
  try
    dialog.Title := title;
    dialog.FileName := default;
    if dialog.Execute then
      Result := BuildString(dialog.Filename);
  finally
    dialog.Free;
  end;
end;

function TJDialogObject.DoOpenFiles(Param: TJValueList): TJValue;
//open dialogJĕ񃊃XgԂ
var
  dialog: TOpenDialog;
  v: TJValue;
  title,default: String;
  sl: TJStringsObject;
begin
  sl := TJStringsObject.Create(FFactory,nil);
  Result := BuildObject(sl);

  title := ChangeFileExt(ExtractFileName(ParamStr(0)),'');
  default := '';
  //^Cg
  if IsParam1(Param) then
  begin
    v := Param[0];
    title := AsString(@v);
  end;
  //ftHgt@C
  if IsParam2(Param) then
  begin
    v := Param[1];
    default := AsString(@v);
  end;

  dialog := TOpenDialog.Create(nil);
  try
    dialog.Title := title;
    dialog.FileName := default;
    dialog.Options := dialog.Options + [ofAllowMultiSelect];
    //̃t@C
    if dialog.Execute then
      sl.FStrings.Assign(dialog.Files);
  finally
    dialog.Free;
  end;
end;

function TJDialogObject.DoOpenFolder(Param: TJValueList): TJValue;
//folderJ
var
  dialog: TFolderDialog;
  v: TJValue;
  title,default: String;
  form: TForm;
begin
  Result := BuildNull;
  title := ChangeFileExt(ExtractFileName(ParamStr(0)),'');
  default := '';
  //^Cg
  if IsParam1(Param) then
  begin
    v := Param[0];
    title := AsString(@v);
  end;
  //ftHgdir
  if IsParam2(Param) then
  begin
    v := Param[1];
    default := AsString(@v);
  end;

  form := TForm.Create(nil);
  form.Position := poMainFormCenter;
  dialog := TFolderDialog.Create(form);
  try
    dialog.Title := title;
    dialog.Directory := default;
    if dialog.Execute then
      Result := BuildString(dialog.Directory);
  finally
    dialog.Free;
    form.Free;
  end;
end;

function TJDialogObject.DoSaveFile(Param: TJValueList): TJValue;
//save dialogJ
var
  dialog: TSaveDialog;
  v: TJValue;
  title,default: String;
begin
  Result := BuildNull;
  title := ChangeFileExt(ExtractFileName(ParamStr(0)),'');
  default := '';
  //^Cg
  if IsParam1(Param) then
  begin
    v := Param[0];
    title := AsString(@v);
  end;
  //ftHgt@C
  if IsParam2(Param) then
  begin
    v := Param[1];
    default := AsString(@v);
  end;

  dialog := TSaveDialog.Create(nil);
  try
    dialog.Title := title;
    dialog.FileName := default;
    if dialog.Execute then
      Result := BuildString(dialog.Filename);
  finally
    dialog.Free;
  end;
end;

{ TJMutexObject }

constructor TJMutexObject.Create(AFactory: TJObjectFactory;
  Param: TJValueList);
var
  s: String;
  v: TJValue;
begin
  inherited;
  RegistName('Mutex');

  if IsParam1(Param) then
  begin
    v := Param[0];
    s := AsString(@v);
  end
  else
    s := '';

  FMutex := TMutex.Create(s);

  RegistMethod('lock',DoLock);
  RegistMethod('unlock',DoUnLock);
  RegistMethod('tryLock', DoTryLock);
end;

destructor TJMutexObject.Destroy;
begin
  FMutex.Free;
  inherited;
end;

function TJMutexObject.DoLock(Param: TJValueList): TJValue;
begin
  EmptyValue(Result);
  FMutex.Lock;
end;

function TJMutexObject.DoTryLock(Param: TJValueList): TJValue;
begin
  Result := BuildBool(FMutex.TryLock);
end;

function TJMutexObject.DoUnLock(Param: TJValueList): TJValue;
begin
  EmptyValue(Result);
  FMutex.UnLock;
end;

function TJMutexObject.GetExisted: Boolean;
begin
  Result := FMutex.Existed;
end;

function TJMutexObject.GetTimeout: Integer;
begin
  Result := FMutex.Timeout;
end;

procedure TJMutexObject.SetTimeout(const Value: Integer);
begin
  FMutex.Timeout := Value;
end;

{ TJKeyboard }

constructor TJKeyboard.Create(AFactory: TJObjectFactory;
  Param: TJValueList);
begin
  inherited;
  RegistName('Keyboard');
  //\bho^
  RegistMethod('isDown',DoIsDown);
end;

function TJKeyboard.DoIsDown(Param: TJValueList): TJValue;
//keyĂ邩ǂH
var
  v: TJValue;
  s: String;
begin
  EmptyValue(Result);
  if IsParam1(Param) then
  begin
    v := Param[0];
    s := AsString(@v);
    if s <> '' then
      Result := BuildBool(GetAsyncKeyState(Integer(s[1])) < 0);
  end;
end;

function TJKeyboard.GetAlt: Boolean;
begin
  Result := GetAsyncKeyState(VK_MENU) < 0;
end;

function TJKeyboard.GetCtrl: Boolean;
begin
  Result := GetAsyncKeyState(VK_CONTROL) < 0;
end;

function TJKeyboard.GetShift: Boolean;
begin
  Result := GetAsyncKeyState(VK_SHIFT) < 0;
end;

{ TJMouse }

constructor TJMouse.Create(AFactory: TJObjectFactory; Param: TJValueList);
begin
  inherited;
  RegistName('Mouse');
end;

function TJMouse.GetLButton: Boolean;
begin
  Result := GetAsyncKeyState(VK_LBUTTON) < 0;
end;

function TJMouse.GetMButton: Boolean;
begin
  Result := GetAsyncKeyState(VK_MBUTTON) < 0;
end;

function TJMouse.GetRButton: Boolean;
begin
  Result := GetAsyncKeyState(VK_RBUTTON) < 0;
end;

function TJMouse.GetX: Integer;
var
  p: TPoint;
begin
  GetCursorPos(p);
  Result := p.X;
end;

function TJMouse.GetY: Integer;
var
  p: TPoint;
begin
  GetCursorPos(p);
  Result := p.Y;
end;


{ TJClipboard }

constructor TJClipboard.Create(AFactory: TJObjectFactory;
  Param: TJValueList);
begin
  inherited;
  RegistName('Clipboard');
  RegistMethod('hasText',DoHasText);
end;

function TJClipboard.DoHasText(Param: TJValueList): TJValue;
begin
  Result := BuildBool(Clipboard.HasFormat(CF_TEXT));
end;

function TJClipboard.GetAsText: String;
begin
  Result := '';
  if Clipboard.HasFormat(CF_TEXT) then
    Result := Clipboard.AsText;
end;

procedure TJClipboard.SetAsText(const Value: String);
begin
  Clipboard.AsText := Value;
end;


{ TJRegIniObject }

constructor TJRegIniObject.Create(AFactory: TJObjectFactory;
  Param: TJValueList);
var
  v: TJValue;
begin
  inherited Create(AFactory,nil);
  RegistName('RegIni');

  RegistMethod('deleteKey',DoDeleteKey);
  RegistMethod('eraseSection',DoEraseSection);
  RegistMethod('readSection',DoReadSection);
  RegistMethod('readSections',DoReadSections);
  RegistMethod('sectionExists',DoSectionExists);
  RegistMethod('write',DoWrite);
  RegistMethod('read',DoRead);

  if IsParam1(Param) then
  begin
    v := Param[0];
    try
      FReg := TRegIniFile.Create(AsString(@v));
      FReg.RootKey := HKEY_CURRENT_USER;
    except
      raise EJThrow.Create(E_INI,'ini create error');
    end;
  end
  else
    raise EJThrow.Create(E_INI,'ini create error');    
end;

destructor TJRegIniObject.Destroy;
begin
  FreeAndNil(FReg);
  inherited;
end;

function TJRegIniObject.DoDeleteKey(Param: TJValueList): TJValue;
var
  v1,v2: TJValue;
begin
  EmptyValue(Result);
  if IsParam2(Param) then
  begin
    v1 := Param[0];
    v2 := Param[1];
    FReg.DeleteKey(AsString(@v1),AsString(@v2));
  end
  else
    raise EJThrow.Create(E_INI,'deleteKey error: ' + FReg.Filename);
end;

function TJRegIniObject.DoEraseSection(Param: TJValueList): TJValue;
var
  v1: TJValue;
begin
  EmptyValue(Result);
  if IsParam1(Param) then
  begin
    v1 := Param[0];
    try
      FReg.EraseSection(AsString(@v1));
    except
      raise EJThrow.Create(E_INI,'eraseSection error: ' + FReg.Filename);
    end;
  end
  else
    raise EJThrow.Create(E_INI,'eraseSection error: ' + FReg.Filename);
end;

function TJRegIniObject.DoRead(Param: TJValueList): TJValue;
var
  v1,v2,v3: TJValue;
begin
  EmptyValue(Result);
  if IsParam3(Param) then
  begin
    v1 := Param[0];
    v2 := Param[1];
    v3 := Param[2];
    Result := BuildString(FReg.ReadString(AsString(@v1),AsString(@v2),AsString(@v3)));
  end
  else
    raise EJThrow.Create(E_INI,'read error: ' + FReg.Filename);
end;

function TJRegIniObject.DoReadSection(Param: TJValueList): TJValue;
var
  v1: TJValue;
  sl: TStringList;
  ss: TJStringsObject;
begin
  EmptyValue(Result); 
  if IsParam1(Param) then
  begin
    v1 := Param[0];
    sl := TStringList.Create;
    try try
      FReg.ReadSection(AsString(@v1),sl);
      ss := TJStringsObject.Create(FFactory,nil);
      ss.FStrings.Assign(sl);
      Result := BuildObject(ss);
    except
      raise EJThrow.Create(E_INI,'readSection error: ' + FReg.Filename);
    end;
    finally
      sl.Free;
    end;
  end
  else
    raise EJThrow.Create(E_INI,'readSection error: ' + FReg.Filename);

end;

function TJRegIniObject.DoReadSections(Param: TJValueList): TJValue;
var
  sl: TStringList;
  ss: TJStringsObject;
begin
  EmptyValue(Result);
  sl := TStringList.Create;
  try try
    FReg.ReadSections(sl);
    ss := TJStringsObject.Create(FFactory,nil);
    ss.FStrings.Assign(sl);
    Result := BuildObject(ss);
  except
    raise EJThrow.Create(E_INI,'readSections error: ' + FReg.Filename);
  end;
  finally
    sl.Free;
  end;
end;

function TJRegIniObject.DoSectionExists(Param: TJValueList): TJValue;
var
  v: TJValue;
begin
  if IsParam1(Param) then
  begin
    v := Param[0];
    Result := BuildBool(FReg.KeyExists(AsString(@v)));
  end
  else
    Result := BuildBool(False);
end;

function TJRegIniObject.DoWrite(Param: TJValueList): TJValue;
var
  v1,v2,v3: TJValue;
begin
  EmptyValue(Result);
  if IsParam3(Param) then
  begin
    v1 := Param[0];
    v2 := Param[1];
    v3 := Param[2];
    FReg.WriteString(AsString(@v1),AsString(@v2),AsString(@v3));
  end
  else
    raise EJThrow.Create(E_INI,'write error: ' + FReg.Filename);
end;

function TJRegIniObject.GetKey: String;
begin
  Result := FReg.FileName;
end;

function TJRegIniObject.GetRootKey: String;
begin
  Result := 'HKEY_CURRENT_USER';
end;



end.
